Index: /LMDZ5/trunk/libf/phylmd/phys_output_write.h
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_output_write.h	(revision 1538)
+++ /LMDZ5/trunk/libf/phylmd/phys_output_write.h	(revision 1539)
@@ -1579,17 +1932,222 @@
        IF (o_dulif%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_u_lif(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_dulif%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dulif%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
         IF (o_dvlif%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_v_lif(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_dvlif%name,itau_w,zx_tmp_fi3d)
-       ENDIF
-        ENDIF
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dvlif%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+        IF (o_dtlif%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=d_t_lif(1:klon,1:klev)/pdtphys
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dtlif%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+        ENDIF
+
+       IF (ok_hines) THEN
+       IF (o_duhin%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=d_u_hin(1:klon,1:klev)/pdtphys
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_duhin%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+
+        IF (o_dvhin%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=d_v_hin(1:klon,1:klev)/pdtphys
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dvhin%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+        IF (o_dthin%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=d_t_hin(1:klon,1:klev)/pdtphys
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dthin%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+        ENDIF
+
+       IF (o_rsu%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rsu%name,itau_w,swup)
+       ENDIF
+       IF (o_rsd%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rsd%name,itau_w,swdn)
+       ENDIF
+       IF (o_rlu%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rlu%name,itau_w,lwup)
+       ENDIF
+       IF (o_rld%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rld%name,itau_w,lwdn)
+       ENDIF
+
+       IF (o_rsucs%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rsucs%name,itau_w,swup0)
+       ENDIF
+       IF (o_rsdcs%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rsdcs%name,itau_w,swdn0)
+       ENDIF
+       IF (o_rlucs%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rlucs%name,itau_w,lwup0)
+       ENDIF
+       IF (o_rldcs%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rldcs%name,itau_w,lwdn0)
+       ENDIF
+
+       IF (o_tnt%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=d_t(1:klon,1:klev)+
+     $d_t_dyn(1:klon,1:klev)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_tnt%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_tntr%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=heat(1:klon,1:klev)/RDAY -
+     $cool(1:klon,1:klev)/RDAY
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_tntr%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_tntscpbl%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)= (d_t_lsc(1:klon,1:klev)+
+     $                             d_t_eva(1:klon,1:klev)+
+     $                             d_t_vdf(1:klon,1:klev))/pdtphys
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_tntscpbl%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_tnhus%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=d_qx(1:klon,1:klev,ivap)+
+     $d_q_dyn(1:klon,1:klev)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_tnhus%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_tnhusscpbl%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=d_q_lsc(1:klon,1:klev)/pdtphys+
+     $                           d_q_eva(1:klon,1:klev)/pdtphys
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_tnhusscpbl%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_evu%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_evu%name,itau_w,coefm)
+       ENDIF
+
+       IF (o_h2o%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=q_seri(1:klon,1:klev)+
+     $                           ql_seri(1:klon,1:klev) 
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_h2o%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_mcd%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=-1 * (dnwd(1:klon,1:klev)+
+     $                                 dnwd0(1:klon,1:klev)) 
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_mcd%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_dmc%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=upwd(1:klon,1:klev) +
+     $  dnwd(1:klon,1:klev)+ dnwd0(1:klon,1:klev) 
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dmc%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+       IF (o_ref_liq%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_ref_liq%name,itau_w,ref_liq)
+       ENDIF
+
+       IF (o_ref_ice%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_ref_ice%name,itau_w,ref_ice)
+       ENDIF
+
+      if (RCO2_per.NE.RCO2_act.OR.RCH4_per.NE.RCH4_act.OR.
+     $ RN2O_per.NE.RN2O_act.OR.RCFC11_per.NE.RCFC11_act.OR.
+     $ RCFC12_per.NE.RCFC12_act) THEN
+
+       IF (o_rsut4co2%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi2d(1 : klon) = swupp ( 1 : klon, klevp1 )
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rsut4co2%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_rlut4co2%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi2d(1 : klon) = lwupp ( 1 : klon, klevp1 )
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rlut4co2%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_rsutcs4co2%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi2d(1 : klon) = swup0p ( 1 : klon, klevp1 )
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rsutcs4co2%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_rlutcs4co2%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi2d(1 : klon) = lwup0p ( 1 : klon, klevp1 )
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rlutcs4co2%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_rsu4co2%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rsu4co2%name,itau_w,swupp)
+       ENDIF
+
+       IF (o_rlu4co2%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rlu4co2%name,itau_w,lwupp)
+       ENDIF
+
+       IF (o_rsucs4co2%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rsucs4co2%name,itau_w,swup0p)
+       ENDIF
+
+       IF (o_rlucs4co2%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rlucs4co2%name,itau_w,lwup0p)
+       ENDIF
+
+       IF (o_rsd4co2%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rsd4co2%name,itau_w,swdnp)
+       ENDIF
+
+       IF (o_rld4co2%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rld4co2%name,itau_w,lwdnp)
+       ENDIF
+
+       IF (o_rsdcs4co2%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rsdcs4co2%name,itau_w,swdn0p)
+       ENDIF
+
+       IF (o_rldcs4co2%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rldcs4co2%name,itau_w,lwdn0p)
+       ENDIF
+
+      endif
 
         if (nqtot.GE.3) THEN
          DO iq=3,nqtot
        IF (o_trac(iq-2)%flag(iff)<=lev_files(iff)) THEN
-         CALL histwrite_phy(nid_files(iff),
+         CALL histwrite_phy(nid_files(iff),clef_stations(iff),
      s                  o_trac(iq-2)%name,itau_w,qx(:,:,iq))
        ENDIF
@@ -1599,5 +2157,5 @@
       if (ok_sync) then
 c$OMP MASTER
-        call histsync(nid_files(iff))
+      call histsync(nid_files(iff))
 c$OMP END MASTER
       endif
Index: /LMDZ5/trunk/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_state_var_mod.F90	(revision 1538)
+++ /LMDZ5/trunk/libf/phylmd/phys_state_var_mod.F90	(revision 1539)
@@ -280,4 +280,28 @@
       REAL,ALLOCATABLE,SAVE :: albpla(:)
 !$OMP THREADPRIVATE(albpla)
+
+!IM ajout variables CFMIP2/CMIP5
+      REAL,ALLOCATABLE,SAVE :: heatp(:,:), coolp(:,:)
+!$OMP THREADPRIVATE(heatp, coolp)
+      REAL,ALLOCATABLE,SAVE :: heat0p(:,:), cool0p(:,:)
+!$OMP THREADPRIVATE(heat0p, cool0p)
+      REAL,ALLOCATABLE,SAVE :: radsolp(:), topswp(:), toplwp(:)
+!$OMP THREADPRIVATE(radsolp, topswp, toplwp)
+      REAL,ALLOCATABLE,SAVE :: albplap(:)
+!$OMP THREADPRIVATE(albplap)
+      REAL,ALLOCATABLE,SAVE :: solswp(:), sollwp(:)
+!$OMP THREADPRIVATE(solswp, sollwp)
+      REAL,ALLOCATABLE,SAVE :: sollwdownp(:)
+!$OMP THREADPRIVATE(sollwdownp)
+      REAL,ALLOCATABLE,SAVE :: topsw0p(:),toplw0p(:)
+      REAL,ALLOCATABLE,SAVE :: solsw0p(:),sollw0p(:)
+!$OMP THREADPRIVATE(topsw0p,toplw0p,solsw0p,sollw0p)
+      REAL,ALLOCATABLE,SAVE :: lwdn0p(:,:), lwdnp(:,:)
+      REAL,ALLOCATABLE,SAVE :: lwup0p(:,:), lwupp(:,:)
+!$OMP THREADPRIVATE(lwdn0p, lwdnp, lwup0p, lwupp)
+      REAL,ALLOCATABLE,SAVE :: swdn0p(:,:), swdnp(:,:)
+      REAL,ALLOCATABLE,SAVE :: swup0p(:,:), swupp(:,:)
+!$OMP THREADPRIVATE(swdn0p, swdnp, swup0p, swupp)
+
 ! pbase : cloud base pressure
 ! bbase : cloud base buoyancy
@@ -446,4 +470,18 @@
       ALLOCATE(topsw0(klon),toplw0(klon),solsw0(klon),sollw0(klon))
       ALLOCATE(albpla(klon))
+!IM ajout variables CFMIP2/CMIP5
+      ALLOCATE(heatp(klon,klev), coolp(klon,klev))
+      ALLOCATE(heat0p(klon,klev), cool0p(klon,klev))
+      ALLOCATE(radsolp(klon), topswp(klon), toplwp(klon))
+      ALLOCATE(albplap(klon))
+      ALLOCATE(solswp(klon), sollwp(klon))
+      ALLOCATE(sollwdownp(klon))
+      ALLOCATE(topsw0p(klon),toplw0p(klon))
+      ALLOCATE(solsw0p(klon),sollw0p(klon))
+      ALLOCATE(lwdn0p(klon,klevp1), lwdnp(klon,klevp1))
+      ALLOCATE(lwup0p(klon,klevp1), lwupp(klon,klevp1))
+      ALLOCATE(swdn0p(klon,klevp1), swdnp(klon,klevp1))
+      ALLOCATE(swup0p(klon,klevp1), swupp(klon,klevp1))
+
       ALLOCATE(cape(klon))
       ALLOCATE(pbase(klon),bbase(klon))
@@ -539,4 +577,17 @@
       deallocate(topsw0,toplw0,solsw0,sollw0)
       deallocate(albpla)
+!IM ajout variables CFMIP2/CMIP5
+      deallocate(heatp, coolp)
+      deallocate(heat0p, cool0p)
+      deallocate(radsolp, topswp, toplwp)
+      deallocate(albplap)
+      deallocate(solswp, sollwp)
+      deallocate(sollwdownp)
+      deallocate(topsw0p,toplw0p)
+      deallocate(solsw0p,sollw0p)
+      deallocate(lwdn0p, lwdnp)
+      deallocate(lwup0p, lwupp)
+      deallocate(swdn0p, swdnp)
+      deallocate(swup0p, swupp)
       deallocate(cape)
       deallocate(pbase,bbase)
Index: /LMDZ5/trunk/libf/phylmd/physiq.F
===================================================================
--- /LMDZ5/trunk/libf/phylmd/physiq.F	(revision 1538)
+++ /LMDZ5/trunk/libf/phylmd/physiq.F	(revision 1539)
@@ -44,4 +44,6 @@
 
 
+!IM stations CFMIP
+      USE CFMIP_point_locations
       IMPLICIT none
 c======================================================================
@@ -699,4 +701,5 @@
 cAA
       REAL coefh(klon,klev)     ! coef d'echange pour phytrac, valable pour 2<=k<=klev
+      REAL coefm(klon,klev)     ! coef d'echange pour U, V
       REAL u1(klon)             ! vents dans la premiere couche U
       REAL v1(klon)             ! vents dans la premiere couche V
@@ -1011,4 +1014,5 @@
       REAL zx_tmp_fi2d(klon)      ! variable temporaire grille physique
       REAL zx_tmp_fi3d(klon,klev) ! variable temporaire pour champs 3D 
+      REAL zx_tmp_fi3d1(klon,klev+1) !variable temporaire pour champs 3D (kelvp1)
 c#ifdef histNMC
 cym   A voir plus tard !!!!
@@ -1041,6 +1045,4 @@
       REAL ue_lay(klon,klev) ! transport zonal de l'energie a chaque niveau vert.
       REAL uq_lay(klon,klev) ! transport zonal de l'eau a chaque niveau vert.
-c
-cIM 280405 END
 c
       INTEGER nhori, nvert, nvert1, nvert3
@@ -1188,4 +1190,30 @@
       REAL grain(1), gtsol(1), gt2m(1), gprw(1)
 
+cIM stations CFMIP
+      INTEGER, SAVE :: nCFMIP
+c$OMP THREADPRIVATE(nCFMIP)
+      INTEGER, PARAMETER :: npCFMIP=120
+      INTEGER, ALLOCATABLE, SAVE :: tabCFMIP(:)
+      REAL, ALLOCATABLE, SAVE :: lonCFMIP(:), latCFMIP(:)
+c$OMP THREADPRIVATE(tabCFMIP, lonCFMIP, latCFMIP) 
+      INTEGER, ALLOCATABLE, SAVE :: tabijGCM(:)
+      REAL, ALLOCATABLE, SAVE :: lonGCM(:), latGCM(:)
+c$OMP THREADPRIVATE(tabijGCM, lonGCM, latGCM)
+      INTEGER, ALLOCATABLE, SAVE :: iGCM(:), jGCM(:)
+c$OMP THREADPRIVATE(iGCM, jGCM)
+      logical, dimension(nfiles)            :: phys_out_filestations
+      logical, parameter :: lNMC=.FALSE.
+
+cIM betaCRF
+      REAL, SAVE :: pfree, beta_pbl, beta_free
+c$OMP THREADPRIVATE(pfree, beta_pbl, beta_free)
+      REAL, SAVE :: lon1_beta,  lon2_beta, lat1_beta, lat2_beta
+c$OMP THREADPRIVATE(lon1_beta,  lon2_beta, lat1_beta, lat2_beta)
+      LOGICAL, SAVE :: mskocean_beta
+c$OMP THREADPRIVATE(mskocean_beta)
+      REAL, dimension(klon, klev) :: beta       ! facteur sur cldtaurad et cldemirad pour evaluer les retros liees aux CRF
+      REAL, dimension(klon, klev) :: cldtaurad  ! epaisseur optique pour radlwsw,COSP
+      REAL, dimension(klon, klev) :: cldemirad  ! emissivite pour radlwsw,COSP 
+
 cIM for NMC files
       missing_val=nf90_fill_real
@@ -1472,7 +1500,42 @@
 
 c================================================================================
-
+cIM stations CFMIP
+      nCFMIP=npCFMIP
+      OPEN(98,file='npCFMIP_param.data',status='old',
+     $          form='formatted',err=999)
+      READ(98,*,end=998) nCFMIP
+998   CONTINUE
+      CLOSE(98)
+      CONTINUE
+      IF(nCFMIP.GT.npCFMIP) THEN
+       print*,'nCFMIP > npCFMIP : augmenter npCFMIP et recompiler'
+       CALL abort
+      else
+       print*,'physiq npCFMIP=',npCFMIP,'nCFMIP=',nCFMIP
+      ENDIF
+c
+      ALLOCATE(tabCFMIP(nCFMIP))
+      ALLOCATE(lonCFMIP(nCFMIP), latCFMIP(nCFMIP))
+      ALLOCATE(tabijGCM(nCFMIP))
+      ALLOCATE(lonGCM(nCFMIP), latGCM(nCFMIP))
+      ALLOCATE(iGCM(nCFMIP), jGCM(nCFMIP))
+c
+c lecture des nCFMIP stations CFMIP, de leur numero 
+c et des coordonnees geographiques lonCFMIP, latCFMIP
+c
+         CALL read_CFMIP_point_locations(nCFMIP, tabCFMIP, 
+     $lonCFMIP, latCFMIP)
+c
+c identification des
+c 1) coordonnees lonGCM, latGCM des points CFMIP dans la grille de LMDZ
+c 2) indices points tabijGCM de la grille physique 1d sur klon points
+c 3) indices iGCM, jGCM de la grille physique 2d
+c
+         CALL LMDZ_CFMIP_point_locations(nCFMIP, lonCFMIP, latCFMIP,
+     $tabijGCM, lonGCM, latGCM, iGCM, jGCM)
+c
+999      CONTINUE
          ENDIF !debut
-
+ 
            DO i=1,klon
              rugoro(i) = f_rugoro * MAX(1.0e-05, zstd(i)*zsig(i)/2.0)
@@ -1512,6 +1575,4 @@
      .                   lmt_pas
 c
-cIM 030306 END
-
       capemaxcels = 't_max(X)'
       t2mincels = 't_min(X)'
@@ -1530,9 +1591,12 @@
 
 c$OMP MASTER
-       call phys_output_open(jjmp1,nlevSTD,clevSTD,nbteta, 
-     &                        ctetaSTD,dtime,ok_veget,
-     &                        type_ocean,iflag_pbl,ok_mensuel,ok_journe,
-     &                        ok_hf,ok_instan,ok_LES,ok_ade,ok_aie, 
-     &                        read_climoz, new_aod, aerosol_couple
+       call phys_output_open(rlon,rlat,nCFMIP,tabijGCM,
+     &                       iGCM,jGCM,lonGCM,latGCM,
+     &                       jjmp1,nlevSTD,clevSTD,
+     &                       nbteta, ctetaSTD, dtime,ok_veget,
+     &                       type_ocean,iflag_pbl,ok_mensuel,ok_journe,
+     &                       ok_hf,ok_instan,ok_LES,ok_ade,ok_aie, 
+     &                       read_climoz, phys_out_filestations,
+     &                       new_aod, aerosol_couple
      &                        )
 c$OMP END MASTER
@@ -1555,5 +1619,4 @@
 #endif
 
-cIM 250308bad guide        ecrit_hf2mth = 30*1/ecrit_hf 
          ecrit_hf2mth = ecrit_mth/ecrit_hf
 
@@ -1568,5 +1631,4 @@
          ecrit_reg = ecrit_reg * un_jour
          ecrit_tra = ecrit_tra * un_jour
-         ecrit_ISCCP = ecrit_ISCCP * un_jour
          ecrit_LES = ecrit_LES * un_jour
 c
@@ -1574,6 +1636,4 @@
      .   ecrit_hf,ecrit_day,ecrit_mth,ecrit_reg,ecrit_tra,ecrit_ISCCP,
      .   ecrit_hf2mth
-cIM 030306 END
-
 
 cXXXPB Positionner date0 pour initialisation de ORCHIDEE
@@ -1633,4 +1693,36 @@
       END IF
 C$omp end single
+c
+cIM betaCRF
+      pfree=70000. !Pa
+      beta_pbl=1.
+      beta_free=1.
+      lon1_beta=-180.
+      lon2_beta=+180.
+      lat1_beta=90.
+      lat2_beta=-90.
+      mskocean_beta=.FALSE.
+
+      OPEN(99,file='beta_crf.data',status='old',
+     $          form='formatted',err=9999)
+      READ(99,*,end=9998) pfree
+      READ(99,*,end=9998) beta_pbl
+      READ(99,*,end=9998) beta_free
+      READ(99,*,end=9998) lon1_beta
+      READ(99,*,end=9998) lon2_beta
+      READ(99,*,end=9998) lat1_beta
+      READ(99,*,end=9998) lat2_beta
+      READ(99,*,end=9998) mskocean_beta
+9998  Continue
+      CLOSE(99)
+9999  Continue
+      WRITE(*,*)'pfree=',pfree
+      WRITE(*,*)'beta_pbl=',beta_pbl
+      WRITE(*,*)'beta_free=',beta_free
+      WRITE(*,*)'lon1_beta=',lon1_beta
+      WRITE(*,*)'lon2_beta=',lon2_beta
+      WRITE(*,*)'lat1_beta=',lat1_beta
+      WRITE(*,*)'lat2_beta=',lat2_beta
+      WRITE(*,*)'mskocean_beta=',mskocean_beta
       ENDIF
 !
@@ -1949,5 +2041,5 @@
      s     zxtsol,    zxfluxlat, zt2m,    qsat2m, 
      s     d_t_vdf,   d_q_vdf,   d_u_vdf, d_v_vdf,
-     s     coefh,     slab_wfbils,                
+     s     coefh,     coefm,     slab_wfbils,                
      d     qsol,      zq2m,      s_pblh,  s_lcl,
      d     s_capCL,   s_oliqCL,  s_cteiCL,s_pblT,
@@ -1965,5 +2057,4 @@
 ! ajout des tendances de la diffusion turbulente
       CALL add_phys_tend(d_u_vdf,d_v_vdf,d_t_vdf,d_q_vdf,dql0,'vdf')
-
 !-----------------------------------------------------------------------------------------
 
@@ -2103,5 +2194,4 @@
             enddo
          enddo
-
       
 cc--   Calcul de l'energie disponible ALE (J/kg) et de la puissance disponible ALP (W/m2)
@@ -2524,5 +2614,4 @@
 
 
-
 c  Ajustement sec
 c  ==============
@@ -2740,5 +2829,4 @@
 
 
-
 c
 c Appeler le processus de condensation a grande echelle
@@ -2873,7 +2961,5 @@
      &        tausum_aero, tau3d_aero)
       ELSE
-cIM 170310 BEG
          tausum_aero(:,:,:) = 0.
-cIM 170310 END
          tau_aero(:,:,:,:) = 0.
          piz_aero(:,:,:,:) = 0.
@@ -3149,4 +3235,55 @@
       endif
 c
+cIM betaCRF
+c
+      cldtaurad = cldtau
+      cldemirad = cldemi
+c
+      if(lon1_beta.EQ.-180..AND.lon2_beta.EQ.180..AND.
+     $lat1_beta.EQ.90..AND.lat2_beta.EQ.-90.) THEN
+c
+c global
+c
+       DO k=1, klev
+       DO i=1, klon
+        if (pplay(i,k).GE.pfree) THEN
+         beta(i,k) = beta_pbl
+        else
+         beta(i,k) = beta_free
+        endif
+        if (mskocean_beta) THEN
+         beta(i,k) = beta(i,k) * pctsrf(i,is_oce)
+        endif
+        cldtaurad(i,k) = cldtau(i,k) * beta(i,k)
+        cldemirad(i,k) = cldemi(i,k) * beta(i,k)
+       ENDDO
+       ENDDO 
+c
+      else
+c
+c regional
+c
+       DO k=1, klev
+       DO i=1,klon
+c
+        if (rlon(i).ge.lon1_beta.AND.rlon(i).le.lon2_beta.AND.
+     $      rlat(i).le.lat1_beta.AND.rlat(i).ge.lat2_beta) THEN
+         if (pplay(i,k).GE.pfree) THEN
+          beta(i,k) = beta_pbl
+         else
+          beta(i,k) = beta_free
+         endif
+         if (mskocean_beta) THEN
+          beta(i,k) = beta(i,k) * pctsrf(i,is_oce)
+         endif
+        cldtaurad(i,k) = cldtau(i,k) * beta(i,k)
+        cldemirad(i,k) = cldemi(i,k) * beta(i,k)
+        endif
+c
+       ENDDO
+       ENDDO
+c
+      endif
+c
 c Appeler le rayonnement mais calculer tout d'abord l'albedo du sol.
 c
@@ -3177,5 +3314,5 @@
      e        paprs, pplay,zxtsol,albsol1, albsol2, t_seri,q_seri,
      e        wo(:, :, 1),
-     e        cldfra, cldemi, cldtau,
+     e        cldfra, cldemirad, cldtaurad,
      s        heat,heat0,cool,cool0,radsol,albpla,
      s        topsw,toplw,solsw,sollw,
@@ -3195,10 +3332,18 @@
 #endif
       ELSE
-
+c
+cIM calcul radiatif pour le cas actuel
+c
+       RCO2 = RCO2_act
+       RCH4 = RCH4_act
+       RN2O = RN2O_act
+       RCFC11 = RCFC11_act
+       RCFC12 = RCFC12_act
+c
          CALL radlwsw
      e        (dist, rmu0, fract, 
      e        paprs, pplay,zxtsol,albsol1, albsol2, 
      e        t_seri,q_seri,wo,
-     e        cldfra, cldemi, cldtau,
+     e        cldfra, cldemirad, cldtaurad,
      e        ok_ade, ok_aie,
      e        tau_aero, piz_aero, cg_aero,
@@ -3218,5 +3363,42 @@
      o        topswcf_aero, solswcf_aero)
          
-
+c
+cIM 2eme calcul radiatif pour le cas perturbe ou au moins un
+cIM des taux doit etre different du taux actuel
+cIM Par defaut on a les taux perturbes egaux aux taux actuels
+c
+       if (RCO2_per.NE.RCO2_act.OR.RCH4_per.NE.RCH4_act.OR.
+     $RN2O_per.NE.RN2O_act.OR.RCFC11_per.NE.RCFC11_act.OR.
+     $RCFC12_per.NE.RCFC12_act) THEN
+c
+       RCO2 = RCO2_per
+       RCH4 = RCH4_per
+       RN2O = RN2O_per
+       RCFC11 = RCFC11_per
+       RCFC12 = RCFC12_per
+c
+         CALL radlwsw
+     e        (dist, rmu0, fract, 
+     e        paprs, pplay,zxtsol,albsol1, albsol2, 
+     e        t_seri,q_seri,wo,
+     e        cldfra, cldemi, cldtau,
+     e        ok_ade, ok_aie,
+     e        tau_aero, piz_aero, cg_aero,
+     e        cldtaupi,new_aod,
+     e        zqsat, flwc, fiwc,
+     s        heatp,heat0p,coolp,cool0p,radsolp,albplap,
+     s        topswp,toplwp,solswp,sollwp,
+     s        sollwdownp,
+     s        topsw0p,toplw0p,solsw0p,sollw0p,
+     s        lwdn0p, lwdnp, lwup0p, lwupp, 
+     s        swdn0p, swdnp, swup0p, swupp,
+     s        topswad_aerop, solswad_aerop,
+     s        topswai_aerop, solswai_aerop,
+     o        topswad0_aerop, solswad0_aerop,
+     o        topsw_aerop, topsw0_aerop,
+     o        solsw_aerop, solsw0_aerop,
+     o        topswcf_aerop, solswcf_aerop)
+       endif
+c
       ENDIF ! aerosol_couple
       itaprad = 0
@@ -3384,5 +3566,5 @@
 c
 c  ajout des tendances
-        CALL add_phys_tend(d_u_hin,d_v_hin,d_t_hin,dq0,dql0,'lif')
+        CALL add_phys_tend(d_u_hin,d_v_hin,d_t_hin,dq0,dql0,'hin')
 
       ENDIF
@@ -3397,5 +3579,5 @@
         call writefield_phy('v_seri',v_seri,llm)
         call writefield_phy('t_seri',t_seri,llm)
-        call writefield_phy('q_seri',q_seri,llm)
+	call writefield_phy('q_seri',q_seri,llm)
       endif
 
@@ -3465,5 +3647,5 @@
      $                   prfl(:,1:klev),psfl(:,1:klev),
      $                   pmflxr(:,1:klev),pmflxs(:,1:klev),
-     $                   mr_ozone,cldtau, cldemi)
+     $                   mr_ozone,cldtaurad, cldemirad)
 
 !     L          calipso2D,calipso3D,cfadlidar,parasolrefl,atb,betamol,
@@ -3616,5 +3798,4 @@
 c
 cIM initialisation 5eme fichier de sortie 
-cIM ajoute 5eme niveau 170310 BEG
       twriteSTD(:,:,5)=tlevSTD(:,:)
       qwriteSTD(:,:,5)=qlevSTD(:,:)
@@ -3624,4 +3805,13 @@
       vwriteSTD(:,:,5)=vlevSTD(:,:)
       wwriteSTD(:,:,5)=wlevSTD(:,:)
+c
+cIM initialisation 6eme fichier de sortie 
+      twriteSTD(:,:,6)=tlevSTD(:,:)
+      qwriteSTD(:,:,6)=qlevSTD(:,:)
+      rhwriteSTD(:,:,6)=rhlevSTD(:,:)
+      phiwriteSTD(:,:,6)=philevSTD(:,:)
+      uwriteSTD(:,:,6)=ulevSTD(:,:)
+      vwriteSTD(:,:,6)=vlevSTD(:,:)
+      wwriteSTD(:,:,6)=wlevSTD(:,:)
 cIM for NMC files
       DO n=1, nlevSTD3
Index: /LMDZ5/trunk/libf/phylmd/phystokenc.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phystokenc.F90	(revision 1538)
+++ /LMDZ5/trunk/libf/phylmd/phystokenc.F90	(revision 1539)
@@ -125,4 +125,5 @@
   LOGICAL ok_sync
   CHARACTER(len=12) :: nvar
+  logical, parameter :: lstokenc=.FALSE.
 !
 !======================================================================
@@ -164,8 +165,8 @@
      
      ! Write field phis and aire only once
-     CALL histwrite_phy(physid,"phis",itap,pphis)
-     CALL histwrite_phy(physid,"aire",itap,paire)
-     CALL histwrite_phy(physid,"longitudes",itap,rlon)
-     CALL histwrite_phy(physid,"latitudes",itap,rlat)
+     CALL histwrite_phy(physid,lstokenc,"phis",itap,pphis)
+     CALL histwrite_phy(physid,lstokenc,"aire",itap,paire)
+     CALL histwrite_phy(physid,lstokenc,"longitudes",itap,rlon)
+     CALL histwrite_phy(physid,lstokenc,"latitudes",itap,rlat)
 
   END IF
@@ -288,31 +289,31 @@
 
      ! write fields
-     CALL histwrite_phy(physid,"t",itap,t)
-     CALL histwrite_phy(physid,"mfu",itap,mfu)
-     CALL histwrite_phy(physid,"mfd",itap,mfd)
-     CALL histwrite_phy(physid,"en_u",itap,en_u)
-     CALL histwrite_phy(physid,"de_u",itap,de_u)
-     CALL histwrite_phy(physid,"en_d",itap,en_d)
-     CALL histwrite_phy(physid,"de_d",itap,de_d)
-     CALL histwrite_phy(physid,"coefh",itap,coefh)	
-     CALL histwrite_phy(physid,"fm_th",itap,fm_therm)
-     CALL histwrite_phy(physid,"en_th",itap,entr_therm)
-     CALL histwrite_phy(physid,"frac_impa",itap,frac_impa)
-     CALL histwrite_phy(physid,"frac_nucl",itap,frac_nucl)
-     CALL histwrite_phy(physid,"pyu1",itap,pyu1)
-     CALL histwrite_phy(physid,"pyv1",itap,pyv1)
-     CALL histwrite_phy(physid,"ftsol1",itap,pftsol(:,1))
-     CALL histwrite_phy(physid,"ftsol2",itap,pftsol(:,2))
-     CALL histwrite_phy(physid,"ftsol3",itap,pftsol(:,3))
-     CALL histwrite_phy(physid,"ftsol4",itap,pftsol(:,4))
-     CALL histwrite_phy(physid,"psrf1",itap,ppsrf(:,1))
-     CALL histwrite_phy(physid,"psrf2",itap,ppsrf(:,2))
-     CALL histwrite_phy(physid,"psrf3",itap,ppsrf(:,3))
-     CALL histwrite_phy(physid,"psrf4",itap,ppsrf(:,4))
-     CALL histwrite_phy(physid,"sh",itap,sh)
-     CALL histwrite_phy(physid,"da",itap,da)
-     CALL histwrite_phy(physid,"mp",itap,mp)
-     CALL histwrite_phy(physid,"upwd",itap,upwd)
-     CALL histwrite_phy(physid,"dnwd",itap,dnwd)
+     CALL histwrite_phy(physid,lstokenc,"t",itap,t)
+     CALL histwrite_phy(physid,lstokenc,"mfu",itap,mfu)
+     CALL histwrite_phy(physid,lstokenc,"mfd",itap,mfd)
+     CALL histwrite_phy(physid,lstokenc,"en_u",itap,en_u)
+     CALL histwrite_phy(physid,lstokenc,"de_u",itap,de_u)
+     CALL histwrite_phy(physid,lstokenc,"en_d",itap,en_d)
+     CALL histwrite_phy(physid,lstokenc,"de_d",itap,de_d)
+     CALL histwrite_phy(physid,lstokenc,"coefh",itap,coefh)	
+     CALL histwrite_phy(physid,lstokenc,"fm_th",itap,fm_therm)
+     CALL histwrite_phy(physid,lstokenc,"en_th",itap,entr_therm)
+     CALL histwrite_phy(physid,lstokenc,"frac_impa",itap,frac_impa)
+     CALL histwrite_phy(physid,lstokenc,"frac_nucl",itap,frac_nucl)
+     CALL histwrite_phy(physid,lstokenc,"pyu1",itap,pyu1)
+     CALL histwrite_phy(physid,lstokenc,"pyv1",itap,pyv1)
+     CALL histwrite_phy(physid,lstokenc,"ftsol1",itap,pftsol(:,1))
+     CALL histwrite_phy(physid,lstokenc,"ftsol2",itap,pftsol(:,2))
+     CALL histwrite_phy(physid,lstokenc,"ftsol3",itap,pftsol(:,3))
+     CALL histwrite_phy(physid,lstokenc,"ftsol4",itap,pftsol(:,4))
+     CALL histwrite_phy(physid,lstokenc,"psrf1",itap,ppsrf(:,1))
+     CALL histwrite_phy(physid,lstokenc,"psrf2",itap,ppsrf(:,2))
+     CALL histwrite_phy(physid,lstokenc,"psrf3",itap,ppsrf(:,3))
+     CALL histwrite_phy(physid,lstokenc,"psrf4",itap,ppsrf(:,4))
+     CALL histwrite_phy(physid,lstokenc,"sh",itap,sh)
+     CALL histwrite_phy(physid,lstokenc,"da",itap,da)
+     CALL histwrite_phy(physid,lstokenc,"mp",itap,mp)
+     CALL histwrite_phy(physid,lstokenc,"upwd",itap,upwd)
+     CALL histwrite_phy(physid,lstokenc,"dnwd",itap,dnwd)
 
 
@@ -328,5 +329,5 @@
         nvar='phi_lev'//trim(nvar)
         
-        CALL histwrite_phy(physid,nvar,itap,phi(:,:,k))
+        CALL histwrite_phy(physid,lstokenc,nvar,itap,phi(:,:,k))
      END DO
      
Index: /LMDZ5/trunk/libf/phylmd/write_histdayNMC.h
===================================================================
--- /LMDZ5/trunk/libf/phylmd/write_histdayNMC.h	(revision 1538)
+++ /LMDZ5/trunk/libf/phylmd/write_histdayNMC.h	(revision 1539)
@@ -15,21 +15,37 @@
 ccc
       IF(lev_histdayNMC.EQ.nlevSTD) THEN
-       CALL histwrite_phy(nid_daynmc,"tnondef",itau_w,tnondef(:,:,2))
-       CALL histwrite_phy(nid_daynmc,"ta",itau_w,twriteSTD(:,:,2))
-       CALL histwrite_phy(nid_daynmc,"zg",itau_w,phiwriteSTD(:,:,2))
-       CALL histwrite_phy(nid_daynmc,"hus",itau_w,qwriteSTD(:,:,2))
-       CALL histwrite_phy(nid_daynmc,"hur",itau_w,rhwriteSTD(:,:,2))
-       CALL histwrite_phy(nid_daynmc,"ua",itau_w,uwriteSTD(:,:,2))
-       CALL histwrite_phy(nid_daynmc,"va",itau_w,vwriteSTD(:,:,2))
-       CALL histwrite_phy(nid_daynmc,"wap",itau_w,wwriteSTD(:,:,2))
+       CALL histwrite_phy(nid_daynmc,lNMC,"tnondef",itau_w,
+     $tnondef(:,:,2))
+       CALL histwrite_phy(nid_daynmc,lNMC,"ta",itau_w,
+     $twriteSTD(:,:,2))
+       CALL histwrite_phy(nid_daynmc,lNMC,"zg",itau_w,
+     $phiwriteSTD(:,:,2))
+       CALL histwrite_phy(nid_daynmc,lNMC,"hus",itau_w,
+     $qwriteSTD(:,:,2))
+       CALL histwrite_phy(nid_daynmc,lNMC,"hur",itau_w,
+     $rhwriteSTD(:,:,2))
+       CALL histwrite_phy(nid_daynmc,lNMC,"ua",itau_w,
+     $uwriteSTD(:,:,2))
+       CALL histwrite_phy(nid_daynmc,lNMC,"va",itau_w,
+     $vwriteSTD(:,:,2))
+       CALL histwrite_phy(nid_daynmc,lNMC,"wap",itau_w,
+     $wwriteSTD(:,:,2))
       ELSE IF(lev_histdayNMC.EQ.nlevSTD8) THEN
-       CALL histwrite_phy(nid_daynmc,"tnondef",itau_w,tnondefSTD8)
-       CALL histwrite_phy(nid_daynmc,"ta",itau_w,twriteSTD8)
-       CALL histwrite_phy(nid_daynmc,"zg",itau_w,phiwriteSTD8)
-       CALL histwrite_phy(nid_daynmc,"hus",itau_w,qwriteSTD8)
-       CALL histwrite_phy(nid_daynmc,"hur",itau_w,rhwriteSTD8)
-       CALL histwrite_phy(nid_daynmc,"ua",itau_w,uwriteSTD8)
-       CALL histwrite_phy(nid_daynmc,"va",itau_w,vwriteSTD8)
-       CALL histwrite_phy(nid_daynmc,"wap",itau_w,wwriteSTD8)
+       CALL histwrite_phy(nid_daynmc,lNMC,"tnondef",itau_w,
+     $tnondefSTD8)
+       CALL histwrite_phy(nid_daynmc,lNMC,"ta",itau_w,
+     $twriteSTD8)
+       CALL histwrite_phy(nid_daynmc,lNMC,"zg",itau_w,
+     $phiwriteSTD8)
+       CALL histwrite_phy(nid_daynmc,lNMC,"hus",itau_w,
+     $qwriteSTD8)
+       CALL histwrite_phy(nid_daynmc,lNMC,"hur",itau_w,
+     $rhwriteSTD8)
+       CALL histwrite_phy(nid_daynmc,lNMC,"ua",itau_w,
+     $uwriteSTD8)
+       CALL histwrite_phy(nid_daynmc,lNMC,"va",itau_w,
+     $vwriteSTD8)
+       CALL histwrite_phy(nid_daynmc,lNMC,"wap",itau_w,
+     $wwriteSTD8)
       ENDIF
 c
